------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.8
--  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard
--  /   /         Filename : dmb_rcv_32gbps_16bit_2.vhd
-- /___/   /\     Timestamp : 
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard


--**************************Component Declarations*****************************


component DMB_RCV_32GBPS_16BIT_2 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTXRESET_SPEEDUP    : integer   := 0 -- Set to 1 to speed up sim reset
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GTX0  (X0_Y11)

    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    GTX0_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GTX0_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    GTX0_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GTX0_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    GTX0_RXRUNDISP_OUT                      : out  std_logic_vector(1 downto 0);
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GTX0_RXCLKCORCNT_OUT                    : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    GTX0_RXBYTEISALIGNED_OUT                : out  std_logic;
    GTX0_RXENMCOMMAALIGN_IN                 : in   std_logic;
    GTX0_RXENPCOMMAALIGN_IN                 : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GTX0_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    GTX0_RXRECCLK_OUT                       : out  std_logic;
    GTX0_RXRESET_IN                         : in   std_logic;
    GTX0_RXUSRCLK2_IN                       : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTX0_RXN_IN                             : in   std_logic;
    GTX0_RXP_IN                             : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    GTX0_RXBUFRESET_IN                      : in   std_logic;
    GTX0_RXBUFSTATUS_OUT                    : out  std_logic_vector(2 downto 0);
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GTX0_GTXRXRESET_IN                      : in   std_logic;
    GTX0_MGTREFCLKRX_IN                     : in   std_logic;
    GTX0_PLLRXRESET_IN                      : in   std_logic;
    GTX0_RXPLLLKDET_OUT                     : out  std_logic;
    GTX0_RXRESETDONE_OUT                    : out  std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTX0_TXN_OUT                            : out  std_logic;
    GTX0_TXP_OUT                            : out  std_logic


);
end component;










    ----------------------------- The GTX Wrapper -----------------------------


    dmb_rcv_32gbps_16bit_2_i : DMB_RCV_32GBPS_16BIT_2
    generic map
    (
        WRAPPER_SIM_GTXRESET_SPEEDUP    =>      1
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GTX0  (X0Y11)

        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        GTX0_RXCHARISCOMMA_OUT          =>      ,
        GTX0_RXCHARISK_OUT              =>      ,
        GTX0_RXDISPERR_OUT              =>      ,
        GTX0_RXNOTINTABLE_OUT           =>      ,
        GTX0_RXRUNDISP_OUT              =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GTX0_RXCLKCORCNT_OUT            =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        GTX0_RXBYTEISALIGNED_OUT        =>      ,
        GTX0_RXENMCOMMAALIGN_IN         =>      ,
        GTX0_RXENPCOMMAALIGN_IN         =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTX0_RXDATA_OUT                 =>      ,
        GTX0_RXRECCLK_OUT               =>      ,
        GTX0_RXRESET_IN                 =>      ,
        GTX0_RXUSRCLK2_IN               =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTX0_RXN_IN                     =>      ,
        GTX0_RXP_IN                     =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        GTX0_RXBUFRESET_IN              =>      ,
        GTX0_RXBUFSTATUS_OUT            =>      ,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        GTX0_GTXRXRESET_IN              =>      ,
        GTX0_MGTREFCLKRX_IN             =>      ,
        GTX0_PLLRXRESET_IN              =>      ,
        GTX0_RXPLLLKDET_OUT             =>      ,
        GTX0_RXRESETDONE_OUT            =>      ,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTX0_TXN_OUT                    =>      ,
        GTX0_TXP_OUT                    =>      


    );



    -----------------------Dedicated GTX Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS_GTXE1 instance
    
    q2_clk0_refclk_ibufds_i : IBUFDS_GTXE1
    port map
    (
        O                               =>      ,
        ODIV2                           =>      ,
        CEB                             =>      ,
        I                               =>      ,  -- Connect to package pin V6
        IB                              =>        -- Connect to package pin V5
    );












